{ pkgs ? import <nixpkgs> { } }:

with pkgs;

let
  sql_file = "data/db.sql";
  data_dir = "$(pwd)/.pgdata";

in mkShell {
  buildInputs = [ postgresql ];

  shellHook = ''
    trap "kill 0" EXIT
    export PGDATA="${data_dir}"
    export PGHOST="${data_dir}"

    if [ ! -d ${data_dir} ]; then
      initdb --auth-local=trust --no-locale --encoding=UTF8
    fi

    if ! pg_ctl status; then
      pg_ctl start -o "--unix_socket_directories=${data_dir} --listen_addresses='''"
    fi

    if [ ! -d ${data_dir} ]; then
      psql -d postgres -f ${sql_file}
    fi

    alias psql='psql -d postgres'
    alias nuke='rm -rf ${data_dir}'
  '';
}
